if not _G.PD2Stats then
	_G.PD2Stats = {}
	PD2Stats.loaded_options = {}
	PD2Stats.mod_path = ModPath
	PD2Stats.save_path = SavePath
	PD2Stats.menu_name = "pd2stats_options"
	PD2Stats.players_menu_name = "pd2stats_players"
	PD2Stats.players_util_name = "pd2stats_players_util"
	PD2Stats.players_commend_name = "pd2stats_players_commend"
	PD2Stats.players_report_name = "pd2stats_players_report"
	PD2Stats.write_options = PD2Stats.write_options or {}
	PD2Stats._cheater_call = 1
end

PD2Stats.dofiles = {
	"PD2StatsLua/Options.lua",
	"PD2StatsLua/WriteOptions.lua"
}

PD2Stats.hook_files = {
	["lib/managers/menumanager"] = "PD2StatsLua/MenuManager.lua",
	["lib/network/base/networkpeer"] = "PD2StatsLua/NetworkPeer.lua"
}

if not PD2Stats.setup then
	for p, d in pairs(PD2Stats.dofiles) do
		dofile(ModPath .. d)
	end
	--PD2Stats:Load_options() ENABLE IF ADDING OPTIONS
	PD2Stats.setup = true
end

function PD2Stats:get_user_data(peer_id, user_id, force)
	dohttpreq("http://api.pd2stats.com/cheater/v3/?id=" .. user_id .. "&type=saf&force=" .. force, 
	function(data, id)
		PD2Stats.players = PD2Stats.players or {}
		PD2Stats.players[peer_id] = PD2Stats.players[peer_id] or {}
		PD2Stats.players[peer_id].cheater_info = {}
		for param, val in string.gmatch(data, "([%w_]+)=([%w_]+)") do
			PD2Stats.players[peer_id].cheater_info[param] = val
		end
		if PD2Stats.players[peer_id].cheater_info.error_string ~= "success" and PD2Stats.players[peer_id].cheater_info.error_string ~= "decode_failed" then
			PD2Stats:get_user_data(peer_id, user_id, "0")
			return
		end 
		if PD2Stats.players[peer_id].cheater_info.cheater == "true" then
			log("Cheater true called")
			if PD2Stats.players[peer_id].cheater_info.reason_1 then
				local reason_index = tonumber(PD2Stats.players[peer_id].cheater_info.reason_index)
				for i = 1, reason_index do
					PD2Stats.players[peer_id].cheater_info["reason_" .. i] = string.gsub(PD2Stats.players[peer_id].cheater_info["reason_" .. i], "_", " ")
					log("fix cheat reason called")
				end
				local peer = managers.network:session():peer(peer_id)
				local auto_kick
				for i = 1, reason_index do
					if i == reason_index then
						auto_kick = Network:is_server()
					else
						auto_kick = false
					end
					peer:mark_cheater(peer:name() .. " cheated, reason: " .. PD2Stats.players[peer_id].cheater_info["reason_" .. i], auto_kick, true)
					log("mark cheater called")
				end
			else
				local peer = managers.network:session():peer(peer_id)
				log("cheater but not reasons")
				peer:mark_cheater(peer:name() .. " has cheated, reason ungiven -PD2Stats", false, true) --Network:is_server()?
			end
		end
	end)
end

function PD2Stats:chat_notif(message)
	managers.chat:feed_system_message(ChatManager.GAME, message)
end

function PD2Stats:get_commend_user(peer_id, user_id, commend_type)
	dohttpreq("http://api.pd2stats.com/commend/v1/?type=saf&id=" .. user_id .. "&reason=" .. commend_type, 
	function(data, id) 
		PD2Stats.players = PD2Stats.players or {}
		PD2Stats.players[peer_id] = PD2Stats.players[peer_id] or {}
		PD2Stats.players[peer_id].commend_info = {}
		for param, val in string.gmatch(data, "([%w_]+)=([%w_]+)") do
			PD2Stats.players[peer_id].commend_info[param] = val
		end
		local peer = managers.network:session():peer(peer_id)
		if PD2Stats.players[peer_id].commend_info.error_string == "success" then
			 PD2Stats:chat_notif("You have successfully commended " .. peer:name() .. " by " .. commend_type )
		elseif PD2Stats.players[peer_id].commend_info.error_string == "too_many_reports" then
			 PD2Stats:chat_notif("You have reached your maximum amount of commends for " .. peer:name())
		elseif PD2Stats.players[peer_id].commend_info.error_string == "rate_limit" then
			 PD2Stats:chat_notif("You have reached your daily limit for commending")
		elseif PD2Stats.players[peer_id].commend_info.error_string ~= "success" and PD2Stats.players[peer_id].commend_info.error_string ~= "too_many_reports" then
			PD2Stats:get_commend_user(peer_id, user_id, commend_type)
			return
		end
	end)
end

function PD2Stats:get_report_user(peer_id, user_id, report_type)
	dohttpreq("http://api.pd2stats.com/report/v1/?type=saf&id=" .. user_id .. "&reason=" .. report_type, 
	function(data, id) 
		PD2Stats.players = PD2Stats.players or {}
		PD2Stats.players[peer_id] = PD2Stats.players[peer_id] or {}
		PD2Stats.players[peer_id].report_info = {}
		for param, val in string.gmatch(data, "([%w_]+)=([%w_]+)") do
			PD2Stats.players[peer_id].report_info[param] = val
		end
		local peer = managers.network:session():peer(peer_id)
		if PD2Stats.players[peer_id].report_info.error_string == "success" then
			PD2Stats:chat_notif("You have successfully reported " .. peer:name() .. " for " .. report_type )
		elseif PD2Stats.players[peer_id].report_info.error_string == "too_many_reports" then
			 PD2Stats:chat_notif("You have reached your maximum amount of reports for " .. peer:name())
		elseif PD2Stats.players[peer_id].report_info.error_string == "rate_limit" then
			 PD2Stats:chat_notif("You have reached your daily limit for reporting")
		elseif PD2Stats.players[peer_id].report_info.error_string ~= "success" and PD2Stats.players[peer_id].report_info.error_string ~= "too_many_reports" then
			PD2Stats:get_report_user(peer_id, user_id, report_type)
			return
		end
	end)
end

if RequiredScript then
	local requiredScript = RequiredScript:lower()
	if PD2Stats.hook_files[requiredScript] then
		dofile( ModPath .. PD2Stats.hook_files[requiredScript] )
	end
end


function PD2Stats:refresh_skilltree()
    if managers.network:session() and managers.network:session():peers() then
        for _, peer in pairs(managers.network:session():peers()) do
            if not peer:profile("outfit_string") == "" then
                local peer_outfit = peer:blackmarket_outfit()
                local skilltree = peer_outfit.skills
                local unlocked = 0
                for skilltree, unlocks in pairs(skilltree.skills) do
                    unlocked = unlocked + unlocks
                    if unlocks > 117 then
                        peer:mark_cheater(peer:name() .. " has cheated, reason: Using more skillpoints than available. Skills Unlocked:" .. unlocked, Network:is_server(), true)
                        return
                    end
                end
                if unlocked and unlocked > 120 then
                    peer:mark_cheater(peer:name() .. " has cheated, reason: Using more skillpoints than available. Skills Unlocked:" .. unlocked, Network:is_server(), true)
                end
                if unlocked > (tonumber(peer:level()) + 2 * math.floor(tonumber(peer:level()) / 10)) then
                    peer:mark_cheater(peer:name() .. " has cheated, reason: Using more skillpoints than available Skills Unlocked:" .. unlocked, Network:is_server(), true)
                end
                log(peer:name() .. " Unlocked:" .. unlocked)
            end
        end
    end
end

if Hooks then
	Hooks:PostHook(MenuSceneManager, "set_lobby_character_out_fit", "PD2StatsCharacterOutfit", function(ply)
		PD2Stats:refresh_skilltree()
	end)
	--[[Hooks:PostHook( LobbyOptionInitiator, "modify_node", "pd2stats_lobby_entered", function(ply)
		log("Lobby option modify")
		--PD2Stats:refresh_players()
		for _, peer in pairs(managers.network:session():peers()) do
			PD2Stats:get_user_data(peer:id(), peer:user_id(), "1")
		end
	end )]]--
	Hooks:Add("BaseNetworkSessionOnEnteredLobby", "PD2StatsOnEnteredLobby", function(local_peer, id)
		log("Hook BaseNetworkSessionOnEnteredLobby called")
		--PD2Stats:refresh_players()
		for _, peer in pairs(managers.network:session():peers()) do
			PD2Stats:get_user_data(peer:id(), peer:user_id(), "1")
		end
	end)
	--[[Hooks:Add("NetworkGameOnGameJoined", "PD2StatsOnGameJoined", function(local_peer, id)
		log("Hook NetworkGameOnGameJoined called")
		--PD2Stats:refresh_players()
		if managers.network:session() and managers.network:session():peers() then
			for _, peer in pairs(managers.network:session():peers()) do
				PD2Stats:get_user_data(peer:id(), peer:user_id(), "1")
			end
		end
	end)]]--
	Hooks:Add("BaseNetworkSessionOnPeerEnteredLobby", "PD2StatsOnPeerEnteredLobby", function(peer, id)
		log("Hook BaseNetworkSessionOnPeerEnteredLobby called")
		--PD2Stats:refresh_players()
		--PD2Stats:refresh_skilltree()
		PD2Stats:get_user_data(id, peer:user_id(), "1")
	end)
	Hooks:Add("NetworkManagerOnPeerAdded", "PD2StatsOnPeerAdded", function(peer, id)
		log("Hook NetworkGameOnPeerAdded called")
		--PD2Stats:refresh_players()
		PD2Stats:get_user_data(id, peer:user_id(), "1")
	end)
	--[[Hooks:Add("BaseNetworkSessionOnPeerRemoved", "pd2stats_peer_removed_test", function(peer, id, reason)
		log("Hook BaseNetworkSessionOnPeerRemoved called")
		PD2Stats:refresh_players()
	end)]]--
	Hooks:Add("BaseNetworkSessionOnLoadComplete", "PD2StatsOnLoadComplete", function(peer, id)
		log("Hook BaseNetworkSessionOnLoadComplete called")
		--PD2Stats:refresh_players()
		if managers.network:session() and managers.network:session():peers() then
			for _, peer in pairs(managers.network:session():peers()) do
				PD2Stats:get_user_data(peer:id(), peer:user_id(), "1")
			end
		end
	end)
	
	Hooks:Add("LocalizationManagerPostInit", "PD2Stats_Localization", function(loc)
        if Idstring("russian"):key() == SystemInfo:language():key() then
			LocalizationManager:load_localization_file(PD2Stats.mod_path ..  "/Localization/russian.txt" )
        elseif Idstring("french"):key() == SystemInfo:language():key() then
            LocalizationManager:load_localization_file(PD2Stats.mod_path ..  "/Localization/french.txt" )
		else
			LocalizationManager:load_localization_file(PD2Stats.mod_path ..  "/Localization/english.txt" )
		end
        
	end)

	Hooks:Add("MenuManagerSetupCustomMenus", "Base_SetupPD2StatsMenu", function( menu_manager, nodes )
		MenuHelper:NewMenu( PD2Stats.menu_name )
		MenuHelper:NewMenu( PD2Stats.players_menu_name )
		MenuHelper:NewMenu( PD2Stats.players_util_name )
		MenuHelper:NewMenu( PD2Stats.players_commend_name )
		MenuHelper:NewMenu( PD2Stats.players_report_name )
	end)
	 
	Hooks:Add("MenuManagerPopulateCustomMenus", "Base_PopulatePD2StatsMenu", function( menu_manager, nodes )
		MenuCallbackHandler.pd2stats_view_steam_profile = function(this, item)
			Steam:overlay_activate("url", "http://steamcommunity.com/profiles/" .. PD2Stats.current_user_id)
		end
		MenuHelper:AddButton({
			id = "steam_profile_view",
			title = "pd2stats_view_steam_profile",
			desc = "pd2stats_view_steam_profile_help",
			callback = "pd2stats_view_steam_profile",
			--back_callback = ,
			--next_node = ,
			menu_id = PD2Stats.players_util_name,
			priority = 1
		})
		MenuCallbackHandler.pd2stats_view_pd2stats_profile = function(this, item)
			Steam:overlay_activate("url", "http://pd2stats.com/profiles/" .. PD2Stats.current_user_id)
		end
		MenuHelper:AddButton({
			id = "pd2stats_profile_view",
			title = "pd2stats_view_pd2stats_profile",
			desc = "pd2stats_view_pd2sats_profile_help",
			callback = "pd2stats_view_pd2stats_profile",
			--back_callback = ,
			--next_node = ,
			menu_id = PD2Stats.players_util_name,
			priority = 2
		})
		
		MenuCallbackHandler.pd2stats_commend = function(this, item)
			PD2Stats:get_commend_user(PD2Stats.current_peer_id, PD2Stats.current_user_id, item._parameters.name)
		end
		MenuHelper:AddButton({
			id = "teacher",
			title = "pd2stats_commend_teacher",
			desc = "pd2stats_commend_teacher_help",
			callback = "pd2stats_commend",
			--back_callback = ,
			--next_node = ,
			menu_id = PD2Stats.players_commend_name,
			priority = 1
		})
		MenuHelper:AddButton({
			id = "leader",
			title = "pd2stats_commend_leader",
			desc = "pd2stats_commend_leader_help",
			callback = "pd2stats_commend",
			--back_callback = ,
			--next_node = ,
			menu_id = PD2Stats.players_commend_name,
			priority = 2
		})
		MenuHelper:AddButton({
			id = "kind",
			title = "pd2stats_commend_kind",
			desc = "pd2stats_commend_kind_help",
			callback = "pd2stats_commend",
			--back_callback = ,
			--next_node = ,
			menu_id = PD2Stats.players_commend_name,
			priority = 3
		})
		
		MenuCallbackHandler.pd2stats_report = function(this, item)
			PD2Stats:get_report_user(PD2Stats.current_peer_id, PD2Stats.current_user_id, item._parameters.name)
		end
		MenuHelper:AddButton({
			id = "cheating",
			title = "pd2stats_report_cheating",
			desc = "pd2stats_report_cheating_help",
			callback = "pd2stats_report",
			--back_callback = ,
			--next_node = ,
			menu_id = PD2Stats.players_report_name,
			priority = 1
		})
		MenuHelper:AddButton({
			id = "griefing",
			title = "pd2stats_report_griefing",
			desc = "pd2stats_report_griefing_help",
			callback = "pd2stats_report",
			--back_callback = ,
			--next_node = ,
			menu_id = PD2Stats.players_report_name,
			priority = 2
		})
		MenuHelper:AddButton({
			id = "abuse",
			title = "pd2stats_report_abuse",
			desc = "pd2stats_report_abuse_help",
			callback = "pd2stats_report",
			--back_callback = ,
			--next_node = ,
			menu_id = PD2Stats.players_report_name,
			priority = 3
		})
		--[[MenuCallbackHandler.test_clbk = function(this, item)
			--PD2Stats:get_user_data(1, "76561198158042660")
			
		end
		MenuHelper:AddButton({
			id = "test",
			title = "test",
			desc = "test",
			callback = "test_clbk",
			--back_callback = ,
			--next_node = ,
			menu_id = PD2Stats.menu_name,
			priority = 3
		})]]--
		
	end)
	 
	Hooks:Add("MenuManagerBuildCustomMenus", "Base_BuildPD2StatsMenu", function( menu_manager, nodes )
		nodes[PD2Stats.menu_name] = MenuHelper:BuildMenu(PD2Stats.menu_name)
		--MenuHelper:AddMenuItem( MenuHelper.menus.lua_mod_options_menu, PD2Stats.menu_name, "pd2stats_option_button", "pd2stats_option_button_help", 1 )
		
		nodes[PD2Stats.players_util_name] = MenuHelper:BuildMenu(PD2Stats.players_util_name, {area_bg = "half"})
		
		nodes[PD2Stats.players_commend_name] = MenuHelper:BuildMenu(PD2Stats.players_commend_name, {area_bg = "half"})
		nodes[PD2Stats.players_report_name] = MenuHelper:BuildMenu(PD2Stats.players_report_name, {area_bg = "half"})
		
		MenuHelper:AddMenuItem( MenuHelper.menus[PD2Stats.players_util_name], PD2Stats.players_commend_name, "pd2stats_commend_button", "pd2stats_commend_button_help", 3 )
		MenuHelper:AddMenuItem( MenuHelper.menus[PD2Stats.players_util_name], PD2Stats.players_report_name, "pd2stats_report_button", "pd2stats_report_button_help", 4 )
		
		nodes[PD2Stats.players_menu_name] = MenuHelper:BuildMenu(PD2Stats.players_menu_name, {area_bg = "half"})
		PD2Stats.players_menu = nodes[PD2Stats.players_menu_name]
		
		MenuCallbackHandler.pd2stats_apply_userid = function(this, item)
			log("Callback Called")
			log(item._parameters.user_id)
			PD2Stats.current_user_id = item._parameters.user_id 
		end
		MenuCallbackHandler.pd2stats_refresh = function(this, item)
			log("Refresh Players")
			PD2Stats:refresh_players()
		end
		local parent_menu
		local menu_position
		
		if nodes.lobby then
			--MenuHelper:AddMenuItem( nodes.lobby, PD2Stats.players_menu_name, "pd2stats_players_button", "pd2stats_players_button_help", "mute_player", "after")
			parent_menu = nodes.lobby
		elseif not Global.game_settings.single_player then
			--MenuHelper:AddMenuItem( nodes.pause, PD2Stats.players_menu_name, "pd2stats_players_button", "pd2stats_players_button_help", "mute_player", "after")
			parent_menu = nodes.pause
		end
		
		
		if parent_menu then
			log("Parent Menu")
			for k, v in pairs( parent_menu._items ) do
				if "mute_player" == v["_parameters"]["name"] then
					menu_position = k + 1
					break
				end
			end
			local data = {
				type = "CoreMenuItem.Item",
			}
			local params = {
				name = "pd2stats_players_menu",
				text_id = "pd2stats_players_button",
				help_id = "pd2stats_players_button_help",
				callback = "pd2stats_refresh",
				next_node = PD2Stats.players_menu_name
			}
			local new_item = parent_menu:create_item(data, params)
			parent_menu:insert_item(new_item, menu_position)
		end
		--[[for k, v in pairs(nodes) do
			log(k)
		end]]--
	end)
end

function PD2Stats:refresh_players()
	log("Refreshing Players")
	local node = PD2Stats.players_menu
	if node == nil then
		return
	end
	node:clean_items()
	if managers.network:session() and managers.network:session():peers() then
		for _, peer in pairs(managers.network:session():peers()) do
			local params = {
				name = peer:name(),
				text_id = peer:name(),
				callback = "pd2stats_apply_userid",
				to_upper = false,
				rpc = peer:rpc(),
				peer = peer,
				next_node = PD2Stats.players_util_name,
				--help_id = peer:is_host() and managers.localization:text("menu_vote_kick_is_host") or managers.vote:option_vote_kick() and managers.vote:help_text() or "",
				localize = false,
				localize_help = false,
				user_id = peer:user_id(),
				peer_id = peer:id()
			}
			local new_item = node:create_item(nil, params)
			node:add_item(new_item)
		end
	end
	managers.menu:add_back_button(node)
end
